import getUrlContents from '../cdn/getUrlContents';
import { Product } from '../interfaces/ISettings';
import extractFile from './extractFile';
import getSolidpkg from './getSolidpkg';
import readSsnFile from './readSsnFile';

export default async function getPatch(product: Product, from: number, to: number) {
  const solidPkg = await getSolidpkg(product, from, to);

  const bufferArray = await Promise.all(solidPkg.files.map((file) => getUrlContents({ host: 'cdn-patch.swtor.com', path: `/patch/${product}/${product}_${from}to${to}/${file.name}` })));
  const zipFile = bufferArray[bufferArray.length - 1];

  const fileEntries = readSsnFile(zipFile);

  //TODO: verify file entries

  const dvArray = bufferArray.map((buffer) => new DataView(buffer));
  fileEntries.map((entry) => extractFile(entry, dvArray) );

  return fileEntries;
}
